<!-- [QPRTemplateStart: jsobjectqueryutils.js] -->
var _sViewParameterPrefix;

function sGetRoot()
{
  var sRoot = sGetParameterWithAlias(ACT_PARAM_QUERY_ROOT, ACT_PARAM_QUERY_ROOT_SHORT, _sLocation);
  if (!sRoot)
    sRoot = sGetParameter(ACT_PARAM_ASSOCIATION_EXTERNAL_OBJECT_ID, _sLocation);
  if (!sRoot) {
    sRoot = sGetParameter(ACT_PARAM_ASSOCIATION_ID, _sLocation);
    if (sRoot)
      sRoot = sCreateExternalObjectId(PR_PORTAL, NO_ID, sRoot);
  }
  return sRoot;
}

var _sLocation = sGetDocumentLocation();
var _sRoot = sGetRoot();
var _iProductId = iExtractProductId(_sRoot);
var _iModelId = iExtractModelId(_sRoot);
var _iFirstIndex = sGetParameter("FIRST", _sLocation);
var _arFieldDefinitions = new Array(), _arFilters = new Array();
var _arSelectedFields = new Array(), _arShownFields = new Array();
var _arObjectData = new Array();
var _iCurrentHeaderFieldId = 0;
var _bEditingValues = sGetParameter(ACT_PARAM_EDIT, _sLocation) == "1";
var _bAllColumnsAreFixed = true;
var EXTRA_DATA_SERIES = 0;
var EXTRA_DATA_PERIOD = 1;
var EXTRA_DATA_OFFSET = 2;

var CHT_NONE = 0;
var CHT_DEFAULT = 1;
var CHT_PERIOD = 2;
var CHT_SERIES = 3;
var CHT_CUSTOM = 4;

if (!_iFirstIndex)
  _iFirstIndex = 0;

function FieldDefinition(vsName, vsParameters)
{
  this.psName = vsName;
  this.psParameters = vsParameters;
  this.pbIsCurrentlyShown = false;
  this.pbIsShown = false;

  var sAlias = sGetParameter("Alias", this.psParameters);
  if (sAlias && (sAlias != ""))
    this.psAlias = sAlias;
  else
    this.psAlias = vsName;
  
  this.parCustomizations = new Array();
  var sTmp = sGetParameter("ShowHeader", this.psParameters);
  if (!sTmp)
    sTmp = '1';
  this.parCustomizations[0] = sTmp;

  sTmp = sGetParameter("FixedWidth", this.psParameters);
  if (sTmp)
    this.SetFixedColumnWidth(parseInt(sTmp));
  else
    this.SetRelativeColumnWidth(parseInt(sGetParameter("RelativeWidth", this.psParameters)));

  this.parExtraData = new Array();
  var sInitExtraDataFunction = "InitializeDefaultExtraDataFor" + this.sGetFieldCustomizationMode();
  eval("if (typeof " + sInitExtraDataFunction + " != 'undefined') " + sInitExtraDataFunction + "(this);");
}

function FieldDefinition_oMakeCopy(vbCopyCustomizations)
{
  var oField = new FieldDefinition(this.psName, this.psParameters);

  oField.pbIsCurrentlyShown = this.pbIsCurrentlyShown;
  oField.pbIsShown = this.pbIsShown;
  
  if (vbCopyCustomizations) {
     oField.parCustomizations.length = 0;
     for (var i = 0; i < this.parCustomizations.length; ++i)
       oField.parCustomizations[i] = this.parCustomizations[i];

     oField.parExtraData.length = 0;
     for (var i = 0; i < this.parExtraData.length; ++i)
       oField.parExtraData[i] = this.parExtraData[i];
  }
  
  return oField;
}

function FieldDefinition_sGetLabel()
{
  return sGetParameter("Label", this.psParameters);
}

function FieldDefinition_sGetValueType()
{
  return sGetParameter("ValueType", this.psParameters);
}

function FieldDefinition_sGetEnumeration()
{
  return sGetParameter("Enumeration", this.psParameters);
}

function FieldDefinition_iGetRelativeWidth()
{
  if (this.parCustomizations[1] == "0")
    return parseInt(this.parCustomizations[2]);
  return 0;
}

function FieldDefinition_iGetFixedWidth()
{
  if (this.parCustomizations[1] == "1")
    return parseInt(this.parCustomizations[2]);
  return 0;
}

function FieldDefinition_bHasRelativeWidth()
{
  return (this.parCustomizations[1] == "0");
}

function FieldDefinition_iGetColumnHeaderType()
{
  var s = new String(this.parCustomizations[0]);
  return parseInt(s.substr(0, 1));
}

function FieldDefinition_sGetColumnHeaderText()
{
  var s = new String(this.parCustomizations[0]);
  if (parseInt(s.substr(0, 1)) == CHT_CUSTOM)
    return sDecodeURI(s.substr(1, s.length - 1));
  else
    return "";
}

function FieldDefinition_sToURL()
{
  var arTemp = new Array();
  for (var i = 0; i < this.parCustomizations.length; ++i)
    arTemp[i] = sEncodeURI(this.parCustomizations[i]);
  return this.psAlias + ":" + arTemp.join(":");
}

function FieldDefinition_SetColumnHeaderType(viValue)
{
  this.parCustomizations[0] = viValue;
}

function FieldDefinition_SetColumnHeaderText(vsValue)
{
  var s = new String(this.parCustomizations[0]);
  if (parseInt(s.substr(0, 1)) == CHT_CUSTOM)
    this.parCustomizations[0] = s.substr(0, 1) + sEncodeURI(vsValue);
}

function FieldDefinition_SetRelativeColumnWidth(viWidth)
{
  this.parCustomizations[1] = "0";
  this.parCustomizations[2] = viWidth ? viWidth : "1";
}

function FieldDefinition_SetFixedColumnWidth(viWidth)
{
  this.parCustomizations[1] = "1";
  this.parCustomizations[2] = viWidth;
}

function FieldDefinition_bIsFilterOnly()
{
  return (sGetParameter("FilterOnly", this.psParameters) == "1");
}

function FieldDefinition_bIsFieldOnly()
{
  return (sGetParameter("FieldOnly", this.psParameters) == "1");
}

function FieldDefinition_sGetFieldCustomizationMode()
{
  return sGetParameter("FieldCustomization", this.psParameters);
}

function FieldDefinition_sGetFieldCustomization(viId)
{
  var sCustomizations = this.parCustomizations[3];
  if (sCustomizations) {
    var arCustomizations = sCustomizations.split(".");
    return arCustomizations[viId];
  }
}

function FieldDefinition_SetFieldCustomization(viId, vsValue)
{
  var sCustomizations = this.parCustomizations[3];
  var arCustomizations;
  if (sCustomizations)
    arCustomizations = sCustomizations.split(".");
  else
    arCustomizations = [];
  arCustomizations[viId] = vsValue;
  this.parCustomizations[3] = arCustomizations.join(".");
}

function FieldDefinition_oGetExtraData(vsId)
{
  return this.parExtraData[vsId];
}

function FieldDefinition_SetExtraData(vsId, voValue)
{
  this.parExtraData[vsId] = voValue;
}

FieldDefinition.prototype.oMakeCopy = FieldDefinition_oMakeCopy;
FieldDefinition.prototype.sGetLabel = FieldDefinition_sGetLabel;
FieldDefinition.prototype.sGetValueType = FieldDefinition_sGetValueType;
FieldDefinition.prototype.sGetEnumeration = FieldDefinition_sGetEnumeration;
FieldDefinition.prototype.iGetRelativeWidth = FieldDefinition_iGetRelativeWidth;
FieldDefinition.prototype.iGetFixedWidth = FieldDefinition_iGetFixedWidth;
FieldDefinition.prototype.iGetColumnHeaderType = FieldDefinition_iGetColumnHeaderType;
FieldDefinition.prototype.sGetColumnHeaderText = FieldDefinition_sGetColumnHeaderText;
FieldDefinition.prototype.sToURL = FieldDefinition_sToURL;
FieldDefinition.prototype.SetColumnHeaderType = FieldDefinition_SetColumnHeaderType;
FieldDefinition.prototype.SetColumnHeaderText = FieldDefinition_SetColumnHeaderText;
FieldDefinition.prototype.SetRelativeColumnWidth = FieldDefinition_SetRelativeColumnWidth;
FieldDefinition.prototype.SetFixedColumnWidth = FieldDefinition_SetFixedColumnWidth;
FieldDefinition.prototype.bHasRelativeWidth = FieldDefinition_bHasRelativeWidth;
FieldDefinition.prototype.bIsFilterOnly = FieldDefinition_bIsFilterOnly;
FieldDefinition.prototype.bIsFieldOnly = FieldDefinition_bIsFieldOnly;
FieldDefinition.prototype.sGetFieldCustomizationMode = FieldDefinition_sGetFieldCustomizationMode;
FieldDefinition.prototype.sGetFieldCustomization = FieldDefinition_sGetFieldCustomization;
FieldDefinition.prototype.SetFieldCustomization = FieldDefinition_SetFieldCustomization;
FieldDefinition.prototype.oGetExtraData = FieldDefinition_oGetExtraData;
FieldDefinition.prototype.SetExtraData = FieldDefinition_SetExtraData;

function Filter(viBinOp, vsField, varParameters, voExtraData)
{
  this.piBinOp = viBinOp;
  this.psField = vsField;
  this.poField = FoGetFieldDefinition(vsField);
  this.parParameters = new Array();
  for (var i = 0; i < varParameters.length; ++i) {
    this.parParameters.push(varParameters[i]);
  }
  this.poExtraData = voExtraData;
}

function FilterFromString(vsParameters)
{
  var arParams =  vsParameters.split("&");
  this.psField = sDecodeURI(arParams[0]);
  this.piBinOp = arParams[1];
  this.poField = FoGetFieldDefinition(this.psField);
  arParams.splice(0, 2);
  this.parParameters = arParams;
  var sGetExtraDataFunction = "oGetExtraDataFor" + sGetParameter("ValueType", this.poField.psParameters) + "Filter";
  eval("if (typeof " + sGetExtraDataFunction + " != 'undefined') this.poExtraData=" + sGetExtraDataFunction + "(this);");
  if (!(this.poExtraData)) {
    sGetExtraDataFunction = "oGetExtraDataFor" + sGetParameter("FieldCustomization", this.poField.psParameters) + "Filter";
    eval("if (typeof " + sGetExtraDataFunction + " != 'undefined') this.poExtraData=" + sGetExtraDataFunction + "(this);");
  }
}

function Filter_sGetLabel()
{
  var sCustomizationMode = this.poField.sGetFieldCustomizationMode();
  var sLabel = (sCustomizationMode ? eval("sGet" + sCustomizationMode + "FieldName(this)") : this.poField.sGetLabel());
  var sBinOpCondition = FsGetBinOpCondition(this.piBinOp);
  if (sBinOpCondition != "") sLabel = " " + sLabel;

  var sValueType = sGetParameter("ValueType", this.poField.psParameters);
  if (sValueType)
    return eval("sGet" + sValueType + "Label(this, sLabel, sBinOpCondition)");
  return "###"; // This label is used only for fields that don't have corresponding field definition in field definition config file.
}

function Filter_sToString()
{
  return sEncodeURI(this.psField) + "&" + this.piBinOp + "&" + this.parParameters.join("&");
}

Filter.prototype.sGetLabel = Filter_sGetLabel;
FilterFromString.prototype.sGetLabel = Filter_sGetLabel;
Filter.prototype.sToString = Filter_sToString;
FilterFromString.prototype.sToString = Filter_sToString;

function FilterObject(vsLabel, vsObjectId)
{
  this.psLabel = vsLabel;
  this.psObjectId = vsObjectId;
}




function AddFieldDefinition(vsName, vsParameters)
{
  _arFieldDefinitions[_arFieldDefinitions.length] = new FieldDefinition(sDecodeURI(vsName), sDecodeURI(vsParameters));
}

function ReadFiltersFromString(vsFilters)
{
  if (vsFilters && (vsFilters.length > 0)) {
    var iPos = vsFilters.indexOf("&");
    if (iPos >= 0) {
      var iCount = parseInt(vsFilters.slice(0, iPos));
      vsFilters = vsFilters.slice(iPos + 1);
      for (var i = 0; i < iCount; ++i) {
        iPos = vsFilters.indexOf("&");
        if (iPos < 0)
          break;
        var iLen = parseInt(vsFilters.slice(0, iPos));
        vsFilters = vsFilters.slice(iPos + 1);
        var sParams = vsFilters.slice(0, iLen);
        vsFilters = vsFilters.slice(iLen + 1);
        var oFilter = new FilterFromString(sParams);
        _arFilters.push(oFilter);
      }
    }       
  }
}

function sGetDynamicSubHierarchyURL(vsHierarchy, vsFields, vsWhere, vsConfigFile, vsSort, viMaxCount, viFirstIndex, 
  viNumLevelsAtATime, vbUseJavascriptRows, vbIgnoreAccess, vsHierarchyExtraParameters)
{
  var sResult = sSetPlugin(sSetAction(sGetDocumentLocation(), ACT_COM_HIERARCHY), "QPRPORTAL");
  sResult = sSetParameter(ACT_PARAM_QUERY_HIERARCHY_SHORT, 
                          sEncodeURI(vsHierarchy + ":related=1,levels=" + (viNumLevelsAtATime + 1) + vsHierarchyExtraParameters), 
                          sResult);
  sResult = sSetParameter(ACT_PARAM_QUERY_CONFIGURATION_FILE, sEncodeURI(vsConfigFile), sResult);
  if (vsFields)
    sResult = sSetParameter(ACT_PARAM_QUERY_FIELDS_SHORT, vsFields, sResult);
  if (vsWhere)
    sResult = sSetParameter(ACT_PARAM_QUERY_WHERE, vsWhere, sResult);
  if (vsSort)
    sResult = sSetParameter(ACT_PARAM_QUERY_SORT_BY_SHORT, vsSort, sResult);
  sResult = sSetParameter(ACT_PARAM_MAX_ROWS, viMaxCount, sResult);
  sResult = sSetParameter(ACT_PARAM_FIRST_INDEX, viFirstIndex, sResult);
  if (viNumLevelsAtATime)
    sResult = sSetParameter(ACT_PARAM_HIERARCHY_DYNAMIC, viNumLevelsAtATime, sResult);
  if (vbUseJavascriptRows)
    sResult = sSetParameter(ACT_PARAM_QUERY_JAVASCRIPT_ROWS, "1", sResult);
  if (vbIgnoreAccess)
    sResult = sSetParameter(ACT_PARAM_IGNORE_ACCESS, "1", sResult);
  sResult = sRemoveParameter(ACT_PARAM_TEMPLATE, sResult);
  return sResult;
}

function ToggleSortField(vsField)
{
  var sSortBy = sGetCurrentSortBy();
  
  // Child custom attribute ids are separated by comma. Replace those with colon
  if (sSortBy.toLowerCase().indexOf('customattribute') >= 0) {
    sSortBy = sSortBy.replace(/([0-9]+),([0-9]+)/g, function (str, m1, m2) { return m1 + ':' + m2; });
  }
  
  if (vsField.toLowerCase().indexOf('customattribute') >= 0) {
    vsField = vsField.replace(/([0-9]+),([0-9]+)/g, function (str, m1, m2) { return m1 + ':' + m2; });
  }
  
  var arSortBy = sSortBy.split(",");
  var sField;
  for (var i = 0; i < arSortBy.length; ++i) {
    sField = arSortBy[i];
    if ((sField == vsField) || (sField == "-" + vsField))
      break;
  }

  if (i == arSortBy.length) {
    arSortBy.splice(0, 0, vsField); // insert field first
  }
  else {
    if (i == 0) {
      if (sField.charAt(0) == "-") // toggle sort mode ascending/descending
        sField = sField.substr(1);
      else
        sField = "-" + sField;
    }
    arSortBy.splice(i, 1);         // move field to first
    arSortBy.splice(0, 0, sField); 
  }  
  var sNewSortBy = arSortBy.join(",");
  var sUrl = sSetParameter(ACT_PARAM_QUERY_SORT_BY_SHORT, sEncodeURI(sNewSortBy), sGetDocumentLocation());
  sUrl = sSetParameter("FIRST", "0", sUrl);
  OpenView(sUrl, "_self", "body");
}

function sGetCurrentFields()
{
  var sResult = sGetParameterWithAlias(ACT_PARAM_QUERY_FIELDS, ACT_PARAM_QUERY_FIELDS_SHORT, sGetDocumentLocation());
  if ((!sResult) || (sResult == ""))
    sResult = sEncodeURI(_sDefaultQueryFields);
  sResult = sResult.replace(/#/g, '');
  return sResult;
}
  
function sGetCurrentFilters()
{
  var sResult = sGetParameterWithAlias(ACT_PARAM_QUERY_FILTERS, ACT_PARAM_QUERY_FILTERS_SHORT, sGetDocumentLocation());
  if ((!sResult) || (sResult == ""))
    sResult = _sDefaultQueryFilters;
  sResult = sResult.replace(/#/g, '');
  return sResult;
}

function sGetCurrentSortBy()
{
  var sResult = sDecodeURI(sGetParameterWithAlias(ACT_PARAM_QUERY_SORT_BY, ACT_PARAM_QUERY_SORT_BY_SHORT, sGetDocumentLocation()));
  if ((!sResult) || (sResult == ""))
    sResult = _sDefaultQuerySortBy;
  sResult = sResult.replace(/#/g, '');
  return sResult;
}

function sGetCurrentRoots()
{
  return sGetParameterWithAlias(ACT_PARAM_QUERY_ROOT, ACT_PARAM_QUERY_ROOT_SHORT, sGetDocumentLocation());
}

function iGetFirstIndex()
{
  return _iFirstIndex;
}

function ReadFieldCustomizationsFromURL()
{
  var sFields = sGetCurrentFields();
  if (sFields) {
    sFields = sDecodeURI(sFields);
    var arFields = sFields.split(",");
    for (var i = 0; i < arFields.length; ++i) {
      var sField = arFields[i];
      var iPos = sField.indexOf(":");
      if (iPos >= 0) {
        var sFieldName = sField.slice(0, iPos);
        var arCustomizations = sField.slice(iPos + 1).split(":");
        var oField = _arSelectedFields[i];
        oField.parCustomizations = arCustomizations;
        var sInitExtraDataFunction = "InitializeExtraDataFor" + oField.sGetFieldCustomizationMode();
        eval("if (typeof " + sInitExtraDataFunction + " != 'undefined') " + sInitExtraDataFunction + "(oField);");
        _arShownFields[i] = oField.oMakeCopy(true);
      }
    }
  }
}

function slGetQueryFields()
{
  var sFields = sGetCurrentFields();
  sFields = sDecodeURI(sFields);

  var arFields = sFields.split(",");
  for (var i = 0; i < arFields.length; ++i) {
    var sField = arFields[i];
    var iPos = sField.indexOf(":");
    if (iPos >= 0) {
      var sFieldName = sField.slice(0, iPos);
      arFields[i] = sFieldName;
    }
  }
  return arFields;
}

function FoGetFieldDefinition(vsField)
{
  for (var i = 0; i < _arFieldDefinitions.length; ++i) {
    var oField = _arFieldDefinitions[i];
    if ((oField.psAlias == vsField) || (oField.psName == vsField))
      return oField;
  }
  return new FieldDefinition(vsField, ""); // This dummy definition  is used only for fields that don't have corresponding field definition in field definition config file.
}

function FoGetSelectedFieldDefinition(vsField)
{
  for (var i = 0; i < _arSelectedFields.length; ++i) {
    var oField = _arSelectedFields[i];
    if ((oField.psAlias == vsField) || (oField.psName == vsField))
      return oField;
  }
}

function AddObjectData(vsObjectId, vsLabel)
{
  _arObjectData[vsObjectId] = vsLabel;
}

function sGetEnumerationArray(vsEnumerationName)
{
  return eval("_ar" + vsEnumerationName + "Enumeration");
}
                
function sGetEnumerationNameByTypeId(vsEnumerationName, viId)
{
  var arEnumeration = sGetEnumerationArray(vsEnumerationName);
  for (var i = 0; i < arEnumeration.length; ++i) {
    if (arEnumeration[i][0] == viId)
      return arEnumeration[i][1];
  }
}
function sGetmeasurevalueFieldName(voFilter)
{
  var sLabel = voFilter.poField.sGetLabel();
  sLabel += "(" + voFilter.poExtraData + ")";
  return sLabel;
}

function sGetmeasurepathFieldName(voFilter)
{
  var sLabel = voFilter.poField.sGetLabel();
  sLabel += "(" + voFilter.poExtraData + ")";
  return sLabel;
}

function sGetCustomAttributeFieldName(voFilter)
{
  var sLabel = voFilter.poField.sGetLabel();
  sLabel += "(" + voFilter.poExtraData + ")";
  return sLabel;
}

function oGetExtraDataForuserFilter(voFilter)
{
  return oGetExtraDataForusersFilter(voFilter);
}

function oGetExtraDataForusersFilter(voFilter)
{
  if (voFilter.parParameters[1] > 4)
    return "";

  return _arObjectData[voFilter.parParameters[0]];
}

function InitializeExtraDataForaction(voField)
{
  if (!(voField.parCustomizations[3]))
    voField.parCustomizations[3] = "0.0.0.1";
}

function InitializeDefaultExtraDataForaction(voField)
{ 
  voField.parCustomizations[3] = "0.0.0.1";
}

function InitializeExtraDataForpgaction(voField)
{
  if (!(voField.parCustomizations[3]))
    voField.parCustomizations[3] = "1";
}

function InitializeDefaultExtraDataForpgaction(voField)
{ 
  voField.parCustomizations[3] = "1";
}

function InitializeExtraDataForCustomAttribute(voField)
{
  if (!(voField.parCustomizations[3]))
    voField.parCustomizations[3] = "0";
}

function InitializeDefaultExtraDataForCustomAttribute(voField)
{ 
  voField.parCustomizations[3] = "0";
}

function InitializeDefaultExtraDataForworkflow(voField)
{ 
  voField.parCustomizations[3] = "0.";
}

function InitializeDefaultExtraDataForworkflowforworkflowticket(voField)
{ 
  voField.parCustomizations[3] = "";
}

function oGetExtraDataForCustomAttributeFilter(voFilter)
{
  var sId = sDecodeURI(voFilter.parParameters[voFilter.parParameters.length - 1]);
  return _arObjectData[sId];
}

function sRemoveEditingParametersFromURL(vsURL)
{
  if (vsURL)
  {
    vsURL = sRemoveParameter(ACT_PARAM_SUBMITTED_VALUES, vsURL);
    vsURL = sRemoveParametersWithPrefix(ACT_EDITOR_VALUE_NAME_PREFIX, vsURL);
    vsURL = sRemoveParametersWithPrefix(ACT_EDITOR_OLD_VALUE_NAME_PREFIX, vsURL);
  }
  return vsURL;
}

function OnStartEdit()
{
  var oInformationView = oGetInformationView();
  if (oInformationView)
  {
    var sURL = oInformationView.sGetDocumentLocation();
    sURL = sRemoveEditingParametersFromURL(sURL);
    sURL = sSetParameter(ACT_PARAM_EDIT, "1", sURL);
    OpenInformationView(sURL);
  }
}

function InitializeEditMode()
{
  if (_bEditingValues)
    document.write("<input type='hidden' name='" + ACT_PARAM_SUBMITTED_VALUES + "' value='1'>");
}

function sGetDefaultToolbarButtons()
{
  if ((typeof(sGetBookmarkButton) != "undefined") &&
      (typeof(sGetAddToBasketButton) != "undefined") &&
      (typeof(sGetCopyLinkButton) != "undefined"))
    return sGetBookmarkButton() +
           sGetAddToBasketButton() +
           sGetCopyLinkButton();
  else 
    return "";
}

function OnAssociationModified(vbRefreshHierarchy)
{
  var oDetailsPaneFrameset = oGetDetailsPaneFrameset();
  if (oDetailsPaneFrameset && oDetailsPaneFrameset.OnAssociationModifiedFromView)
    oDetailsPaneFrameset.OnAssociationModifiedFromView(vbRefreshHierarchy);
  else if ((parent != window) && (parent.ReloadTree))
    parent.ReloadTree();
  else
    document.location.reload(true);
}

function OnAssociationDeleted(vbRefreshHierarchy)
{
  var oDetailsPaneFrameset = oGetDetailsPaneFrameset();
  if (oDetailsPaneFrameset && oDetailsPaneFrameset.OnAssociationDeletedFromView)
    oDetailsPaneFrameset.OnAssociationDeletedFromView(vbRefreshHierarchy);
  else if ((parent != window) && (parent.ReloadTree))
    parent.ReloadTree();
  else
    document.location.reload(true);
}

function OnAssociationCreated(vbRefreshHierarchy, viAssociationId, vsDetailsUrl)
{
  var oDetailsPaneFrameset = oGetDetailsPaneFrameset();
  if (oDetailsPaneFrameset && oDetailsPaneFrameset.OnAssociationCreatedFromView)
    oDetailsPaneFrameset.OnAssociationCreatedFromView(vbRefreshHierarchy, viAssociationId, vsDetailsUrl);
  else if ((parent != window) && (parent.ReloadTree))
    parent.ReloadTree();
  else
    document.location.reload(true);
}

function SaveFieldCustomizations(voForm)
{
  if (voForm.name == "formTableDesigner") 
  {  
    if (_bSingleFieldEditShown) {
      var iHeaderType = voForm.cbxColumnHeaderText.selectedIndex;
      if (iHeaderType != -1)
        iHeaderType = voForm.cbxColumnHeaderText.options[iHeaderType].value;
      else
        iHeaderType = CHT_NONE;

      _oSelectedField.SetColumnHeaderType(iHeaderType);
      if (iHeaderType == CHT_CUSTOM)
      {
        var sTmp = voForm.txtColumnHeaderText.value;
        _oSelectedField.SetColumnHeaderText(sTmp);
      }
      if (voForm.radWidthType[0].checked)
        _oSelectedField.SetRelativeColumnWidth();
      else
        if (voForm.txtFixedColumnWidth.value == 0)
          _oSelectedField.SetRelativeColumnWidth();
        else
          _oSelectedField.SetFixedColumnWidth(SafeParseInt(voForm.txtFixedColumnWidth.value, _oSelectedField.iGetFixedWidth()));
  
      var sFieldCustomization = _oSelectedField.sGetFieldCustomizationMode();
      if (sFieldCustomization && (sFieldCustomization != ""))
        eval("FSave" + sFieldCustomization + "Customizations(voForm)");
    }
  }
  else
  {
    var sFieldCustomization = _oSelectedField.sGetFieldCustomizationMode();
    if (sFieldCustomization && (sFieldCustomization != ""))
      eval("FSave" + sFieldCustomization + "Customizations(voForm)");   
    }
}

function FSavemeasurevalueCustomizations(voForm)
{
  SaveMeasureSeriesAndPeriodCustomizations(voForm);
}

function FSaveCustomAttributeCustomizations(voForm)
{
   SaveCustomAttributeCustomizations(_oSelectedField, voForm);
}

function FsAppendPrefixedParam(vsTo, vsViewParamPrefix, vsParamName, vsURL)
{
  var sValue = sGetParameter(vsParamName, vsURL);
  if (sValue) {
    if (vsTo.length > 0)
      vsTo += "&";
    vsTo += vsViewParamPrefix + vsParamName + "=" + sValue;
  }
  return vsTo;
}

function CopyParametersToHierarchyViewParameters(vsViewParamPrefix)
{
  _sViewParameterPrefix = vsViewParamPrefix;
  
  var oMainView = oGetMainView();
  if (!oMainView)
    return;
  if (!vsViewParamPrefix)
    vsViewParamPrefix = "";
  oMainView.RegisterAutomaticHierarchyParameter(vsViewParamPrefix + ACT_PARAM_QUERY_FIELDS_SHORT);
  oMainView.RegisterAutomaticHierarchyParameter(vsViewParamPrefix + ACT_PARAM_QUERY_FILTERS_SHORT);
  oMainView.RegisterAutomaticHierarchyParameter(vsViewParamPrefix + ACT_PARAM_QUERY_SORT_BY_SHORT);
  oMainView.RegisterAutomaticHierarchyParameter(vsViewParamPrefix + ACT_PARAM_QUERY_FIELDS);
  oMainView.RegisterAutomaticHierarchyParameter(vsViewParamPrefix + ACT_PARAM_QUERY_FILTERS);
  oMainView.RegisterAutomaticHierarchyParameter(vsViewParamPrefix + ACT_PARAM_QUERY_SORT_BY);
  oMainView.RegisterAutomaticHierarchyParameter(vsViewParamPrefix + ACT_PARAM_RECURSIVE);
  oMainView.RegisterAutomaticHierarchyParameter(vsViewParamPrefix + ACT_PARAM_MODEL_VERSIONS);
  
  if (!oMainView.bIsInformationViewLocked() ||
      (window.bIsNativeView && !bIsNativeView()))
    return;

  var sURL = sGetDocumentLocation();
  var sParams = "";
  sParams = FsAppendPrefixedParam(sParams, vsViewParamPrefix, ACT_PARAM_QUERY_FIELDS_SHORT, sURL);
  sParams = FsAppendPrefixedParam(sParams, vsViewParamPrefix, ACT_PARAM_QUERY_FILTERS_SHORT, sURL);
  sParams = FsAppendPrefixedParam(sParams, vsViewParamPrefix, ACT_PARAM_QUERY_SORT_BY_SHORT, sURL);
  sParams = FsAppendPrefixedParam(sParams, vsViewParamPrefix, ACT_PARAM_QUERY_FIELDS, sURL);
  sParams = FsAppendPrefixedParam(sParams, vsViewParamPrefix, ACT_PARAM_QUERY_FILTERS, sURL);
  sParams = FsAppendPrefixedParam(sParams, vsViewParamPrefix, ACT_PARAM_QUERY_SORT_BY, sURL);
  sParams = FsAppendPrefixedParam(sParams, vsViewParamPrefix, ACT_PARAM_RECURSIVE, sURL);
  sParams = FsAppendPrefixedParam(sParams, vsViewParamPrefix, ACT_PARAM_MODEL_VERSIONS, sURL);
  oMainView.OnForwardHierarchyParametersFromInformationView(sParams);
  
  var oHeaderView = oGetHeaderView();
  if (oHeaderView) {
    var sHierarchyParams = oHeaderView.sGetHierarchyParameters();
    sHierarchyParams = sImportParams(sParams, sHierarchyParams);
    oHeaderView.UpdateHierarchyParametersAndPortalStateWithoutRefresh(sHierarchyParams);
  }
}

function FSavemeasurepathCustomizations(voFrom)
{
}

function bHideTableDesigner()
{
  if (_bEditingValues)
    return true;
  
  var oHierarchyView = oGetHierarchyView();
  return oHierarchyView && 
         (typeof(oHierarchyView.bHideTableDesigner) !== "undefined") && 
         oHierarchyView.bHideTableDesigner();
}

function OnObjectQueryViewLoaded()
{
  if (typeof(OnUpdateViewDesignerAfterViewLoaded) != "undefined")
    OnUpdateViewDesignerAfterViewLoaded();
}

(function() {
  var olStringBuilders = [],
      oStringBuilder,
      iStringsPerBuilder = 0;

  function NewStringBuilder()
  {
    olStringBuilders[olStringBuilders.length] = oStringBuilder =
      new StringBuilder();
  }

  function InitializeBufferedWriteHTML()
  {
    SetCustomHTMLWriter(WriteHTML);
    NewStringBuilder();
  }

  function WriteHTML(vsHTML)
  {
    if ( ++iStringsPerBuilder > 1000 ) {
      NewStringBuilder();
      iStringsPerBuilder = 0;
    }
    oStringBuilder.append(vsHTML);
  }

  function sGetGeneratedHTML()
  {
    var arAccum = [], i;
    for ( i = 0; i < olStringBuilders.length; i++ )
      arAccum[i] = olStringBuilders[i].toString();
    return arAccum.join('');
  }

  window.InitializeBufferedWriteHTML = InitializeBufferedWriteHTML;
  window.WriteHTML = WriteHTML;
  window.sGetGeneratedHTML = sGetGeneratedHTML;
})();

function AddSelectedField(voField)
{
  voField.pbIsShown = voField.pbIsCurrentlyShown = true;
  var oFieldCopy = voField.oMakeCopy();
  _arSelectedFields[_arSelectedFields.length] = oFieldCopy;
}

function InitializeQueryObjects()
{
  var slFields = slGetQueryFields();
  for (var i = 0; i < slFields.length; ++i) {
    var oField = FoGetFieldDefinition(slFields[i]);
    if (oField) {
      AddSelectedField(oField);
      _arShownFields[_arShownFields.length] = oField.oMakeCopy();
    }
  }
  var sFilters = sDecodeURI(sGetParameterWithAlias(ACT_PARAM_QUERY_FILTERS, ACT_PARAM_QUERY_FILTERS_SHORT, sGetDocumentLocation()));
  ReadFiltersFromString(sFilters);
}

function AdjustTable()
{
  var iScrollHeight;
  if (bHasDetailsPane())
  {
    var oDetailsPaneFrameset = oGetDetailsPaneFrameset();
    if (oDetailsPaneFrameset && oDetailsPaneFrameset.bReadyForFixedHeaderTable())
      iScrollHeight = oDetailsPaneFrameset.$('#DetailsPaneViewDiv').height();
  }
  else
  {
    var oInformationView = oGetInformationView();
    if (oInformationView && $.isFunction(oInformationView.iGetMainViewHeight))
      iScrollHeight = oInformationView.iGetMainViewHeight();
    else 
    {
      var oMainView = oGetMainView();
      if (oMainView)
        iScrollHeight = oMainView.$('#InformationView').height();
    }
  }

  if (iScrollHeight)
  {
    var headerHeight = $('#ResizableTable').find('thead').height() + $('#ResizableTableHead').find('thead').height() +
      $('#ResizableTable').find('caption').outerHeight() + $('#ResizableTableHead').find('caption').outerHeight();
    iScrollHeight -= (headerHeight + $('#TabPageControls').outerHeight());
    if ((typeof(_bDesignerShown) !== "undefined") && _bDesignerShown)
      iScrollHeight -= $('#divtabledesigner').height();
    if ($('#Warning'))
      iScrollHeight -= $('#Warning').outerHeight();
    $('#TableBody').height(iScrollHeight);
  }

  var headTable = $('#ResizableTableHead');
  var bodyTable = $('#ResizableTableBody')
  var scrollbarWidth = (headTable.innerWidth() - bodyTable.innerWidth());
  var firstBodyRowCells = bodyTable.find("tbody tr:visible:first>td");
  var headerCells = headTable.find("thead th");

  // Copy last column width from body table to header table and adjust the width by scrollbar width (if any)
  if ((headerCells.length > 0) && (firstBodyRowCells.length > 0))
  {
    var lastHeaderColumn = headerCells.last();
    var lastBodyColumn = firstBodyRowCells.last();
    if (lastHeaderColumn && lastBodyColumn)
      lastHeaderColumn.css("width", (lastBodyColumn.width() + scrollbarWidth) + "px");
  }
  if (typeof resizeQuickFilterTextBoxes === 'function') resizeQuickFilterTextBoxes();

  // If all columns are set to have fixed widths, copy also other column widths back from the first row of the body-table to header-table
  if (_bAllColumnsAreFixed)
    var headerWidths = headerCells.each(function (index) {
      var headerCell = headerCells.eq(index);
      var bodyCell = firstBodyRowCells.eq(index);
      if (headerCell != headerCells.last())
        headerCell.css("width", bodyCell.width() + "px");
    });
}

function MakeTableHeaderFixed(voTable)
{
  if ($("#ResizableTableHead").length > 0)
    return;
  
  // Make a new table and move headers from the existing table to that new table
  var newTable = voTable
    .clone()
    .attr("id", "ResizableTableHead");
  newTable.find("thead tr").remove();
  newTable.find("tbody tr").remove();
  var headTr = voTable.find('thead tr').detach();
  voTable.find('caption').remove();
  var newHead = newTable.find('thead');
  headTr.appendTo(newHead);
  voTable.attr("id", "ResizableTableBody");
  newTable.insertBefore(voTable.parent());
  newTable.wrap("<div/>");

  var firstBodyRowCells = voTable.find("tbody tr:visible:first>td");
  var headerCells = headTr.children("th");

  // Copy fixed column widths from the header-table to first row of the body-table if needed
  var headerWidths = headerCells.each(function (index) {
    var headerCell = headerCells.eq(index);
    var bodyCell = firstBodyRowCells.eq(index);
    if ((bodyCell.length > 0) && headerCell[0].style.width && !bodyCell[0].style.width)
      bodyCell.width(headerCell.width());
  });

  if (typeof initializeQuickFilter === 'function') initializeQuickFilter();
  
  $(window).resize(AdjustTable);
  AdjustTable();
}

function SetupFixedHeaderTable()
{
  if (!bInPortal()) 
    return;
  
  if (!$.isReady)
  {
    $(document).ready(SetupFixedHeaderTable);
    return;
  }
  
  if ($('#ResizableTable').size() == 0) {
	setTimeout(function(){
      MakeTableHeaderFixed($('#ResizableTable'));
    }, 10); 
  } else {
    MakeTableHeaderFixed($('#ResizableTable'));
  }
  
}

<!-- [QPRTemplateEnd: jsobjectqueryutils.js] -->
