////////////////////////////////////////////////////////////////////////
// PUBLIC FUNCTIONS

var _oHTMLObjectSelected = null;
var _oSelectedTreeNode = null;
var _sSelectedObjectId = null;
var _sExpandObjectId = null;
var _sHTMLObjectSelectedClassName = null;
var _sHTMLObjectSelectedName = '';
var _bSkipCollapsed = false;

function SetHTMLObjectSelected(voHTMLObject, vbCheckMatchingHREFWithCurrentSelection, vbNonUserBasedSelection, vbScrollIntoView)
{
  if (vbCheckMatchingHREFWithCurrentSelection && _oHTMLObjectSelected && (_oHTMLObjectSelected.href == voHTMLObject.href)) 
    return;

  var oNewSelectedTreeNode;
  if (voHTMLObject) {
    var iParentNodeId = voHTMLObject.parentNode.id;
    oNewSelectedTreeNode = FoGetTreeNodeByTreeNodeId(iParentNodeId);
    if (vbNonUserBasedSelection && _oSelectedTreeNode && oNewSelectedTreeNode && 
        ((oNewSelectedTreeNode.piNodeId != _oSelectedTreeNode.piNodeId) && (oNewSelectedTreeNode.sFullId == _oSelectedTreeNode.sFullId))) {
      oNewSelectedTreeNode = _oSelectedTreeNode;
      voHTMLObject = FoGetHTMLNodeByTreeNodeId(_oSelectedTreeNode.piNodeId);
    }
  }

  if (_oHTMLObjectSelected) {
    _oHTMLObjectSelected.className = _sHTMLObjectSelectedClassName;
    _sHTMLObjectSelectedClassName = "";
  }
 
  _oHTMLObjectSelected = voHTMLObject;
  _oSelectedTreeNode = oNewSelectedTreeNode;

  if(_oHTMLObjectSelected) {
    _sHTMLObjectSelectedClassName = _oHTMLObjectSelected.className;
    _oHTMLObjectSelected.className = S_SELECTED_CLASS;
    _sHTMLObjectSelectedName = _oHTMLObjectSelected.name;
    _sSelectedObjectId = _oHTMLObjectSelected.id;
    
    // Automatically expand dynamic children of the selected node
    if (_oSelectedTreeNode && _DynamicTreeChildrenCallback && !_bLocked && _oSelectedTreeNode.pbHasDynamicChildren) {
      _oExpandedNode = _oSelectedTreeNode;
      _bLocked = true;
      _DynamicTreeChildrenCallback(_oSelectedTreeNode, FDynamicNodesLoaded);
    }

    if (vbScrollIntoView)
    {
      var selected = $(_oHTMLObjectSelected);
      var firstElement = selected.closest("tbody").children("tr").first().children("td").first().children().first();
      var tableBody = selected.closest("#TableBody");
      if ((firstElement.length > 0) && (tableBody.length > 0))
        tableBody.attr("scrollTop", selected.offset().top - firstElement.offset().top);
      else
        _oHTMLObjectSelected.scrollIntoView();
    }
  } 
}

function ClearTreeSelection()
{
  var undefined;
  SetHTMLObjectSelected(undefined, false);
  _sSelectedObjectId = null;
}

function SetObjectSelectedStateByObjectIdValue(viObjectId, vbScrollIntoView)
{
  var oHTMLNode = document.getElementById(viObjectId);
  if (!oHTMLNode) {
    var oNode = FoGetNodeWithObjectId(viObjectId);
    if (oNode) {
      ShowNode(oNode);
      UpdateTree(FsGetTreeDivName(oNode), true);
      oHTMLNode = document.getElementById(viObjectId);
      if (!oHTMLNode)
        return false;
    }
    else
      return false;
  }
  SetHTMLObjectSelected(oHTMLNode, true, true, vbScrollIntoView);
  return true;
}

// THIS FUNCTION IS DEPRECATED and is here only for backward compatibility
function SetObjectSelectedStateByHrefValue(vsHref, vbSelected)
{
  var iCount=0;

  for (var i=0; i<document.links.length; i++) {
    if (document.links[i].href.indexOf(vsHref) != -1) {
      if (vbSelected == true) { 
        if ((sHTMLObjectSelectedName == '') || 
            (sHTMLObjectSelectedName == document.links[i].name)) {
          if(iCount == 0)
            ++iCount;
          else {
            SetHTMLObjectSelected(document.links[i], true, true);
            break;
          }
        }
      }
    }
  } 
}

// THIS FUNCTION IS DEPRECATED and is here only for backward compatibility
function SetObjectSelectedStateByAidValue(vsHref, vbSelected)
{
  vsHref = sDecodeURI(vsHref);
  var iPos = vsHref.indexOf("AID=");
  var sAid = "";
  if(iPos != -1) {
    sAid = vsHref.substring(parseInt(iPos)+4);
    iPos = sAid.indexOf("&");
    if(iPos != -1) { sAid = "AID=" + sAid.substring(0,iPos); }
  }
  if(sAid == "") return;
  for( var i=0; i<document.links.length; i++) {
    if(document.links[i].href.indexOf(sAid) != -1) {
      if(vbSelected == true) {
        SetHTMLObjectSelected(document.links[i], true, true);
      }
      else {
        SetHTMLObjectSelected(null, true, true);
      }      
    }
  }
}

function sGetSelectedObjectId()
{
  return _sSelectedObjectId;
}

function sGetSelectedName()
{
  var oSelObject = document.getElementById(sGetSelectedObjectId());
  if (oSelObject)
    return oSelObject.title;
  else
    return "";
}


function FIsChildOfHTMLElement(voElement, voParent)
{
  voElement = voElement.parentElement;
  while (voElement) {
    if (voElement == voParent)
      return true;
    voElement = voElement.parentNode;
  } 
  return false;
}

function ShowNode(voNode)
{
  var oParent = voNode.parent;
  while (oParent) {
    oParent.open = true;
    oParent = oParent.parent;
  }
}

function ShowNodeById(viObjectId, vbUpdate)
{
  if (_sSelectedObjectId == viObjectId)
    return true;

  var oNode = FoGetNodeWithObjectId(viObjectId);
  if (!oNode)
    return false;

  ShowNode(oNode);
  if (vbUpdate)
    UpdateTree(FsGetTreeDivName(oNode), true);
  return true;
}

function SetExpandObjectId(viObjectId)
{
  _sExpandObjectId = viObjectId;
}

function ExpandParentNode()
{
  if (_sExpandObjectId == null)
    return;
  var oNode = FoGetNodeWithObjectId(_sExpandObjectId);
  if (oNode) {
    oNode.open = true;
	parent.location.reload(true);	
  }	
}

function OnAfterUpdateTree(vsTreeDivName)
{
  if (_sSelectedObjectId != null) {
    try { 
      // It seems that invalid argument-error is thrown in some cases for some reason in IE in the following line.
      // Added catches to catch all unwanted exceptions (CP22733B)
      SetHTMLObjectSelected(document.getElementById(_sSelectedObjectId), false, true);
    }
    catch(e) {
    }
  }

  if (bExists(self.RestoreTreeState))
    RestoreTreeState();

  if (typeof(OnAfterTreeUpdate) !== "undefined")
    OnAfterTreeUpdate();

  if (typeof SetupFixedHeaderTable === 'function') SetupFixedHeaderTable();
}

function WriteTreeDiv(vsTreeDivName)
{
  if (!vsTreeDivName)
    return FHTMLCreateDiv(ID_TREEDIV);
  return FHTMLCreateDiv(vsTreeDivName);
}

function UpdateTree(vsTreeDivName, vbStoreTreeState)
{
  if (typeof(OnBeforeTreeUpdate) !== "undefined")
    OnBeforeTreeUpdate();

  if (vbStoreTreeState && bExists(self.StoreTreeState))
    StoreTreeState();

  // var DTMStartTime = new Date();
  if (!vsTreeDivName)
    FBWriteToDiv(ID_TREEDIV,FHMTLTreeToHTML(_objSuperNode));
  else
    FBWriteToDiv(vsTreeDivName,FHMTLTreeToHTML(FoGetSuperNode(vsTreeDivName)));
  // var DTMEndTime = new Date();
  // alert(DTMEndTime - DTMStartTime); // DEBUG Drawing times
  OnAfterUpdateTree(vsTreeDivName);
}

function ResizeWindowFix()
{
  if (B_NS4) {
    var undefined;
    UpdateTree(undefined, true);
  }
}

function SetTreeImagePath(urlPath, vbBookmark, vbHideLines, vsImageSuffix)
{
  if (!vsImageSuffix)
    vsImageSuffix = "";
  if (urlPath)
    _urlTreeImagesPath = urlPath;
  FBUpdateTreeImages(vbBookmark, vbHideLines, vsImageSuffix);
}



function SetTreeWidth(sWidth)
{
  sTemp = new String(sWidth);
  _sTreeWidth = sTemp;
}

function SetTreeOwnerDraw(vbSet)
{
  if (vbSet)
    _DrawRowFunc = FHMTLTreeToTableWithOwnerDrawRows;
  else
    _DrawRowFunc = FHMTLTreeToTable;
}

function SetDrawTableFunc(vFunc)
{
  _DrawTableFunc = vFunc;
}

function FCollapseRec(voNode)
{
  var oResult, oCurrentNode = voNode.firstChild;
  while (oCurrentNode) {
    oCurrentNode.open = false;
    FCollapseRec(oCurrentNode);
    oCurrentNode = oCurrentNode.next;
  }
}

function Collapse(vbUpdate)
{
  var oResult, oCurrentNode = _objSuperNode.firstChild;
  while (oCurrentNode) {
    oCurrentNode.open = false;
    FCollapseRec(oCurrentNode);
    oCurrentNode = oCurrentNode.next;
  }
  if (vbUpdate)
    UpdateTree(FsGetTreeDivName(_objSuperNode), true);
}


function NewImage(vsImageFileName, vsTitle)
{
  if (vsImageFileName.indexOf('://') == -1) 
    return FHTMLCreateTreeImage(_urlTreeImagesPath + vsImageFileName, vsTitle);
  return FHTMLCreateTreeImage(vsImageFileName, vsTitle);
}

function AddFolder(vsHtmlText, vbOpen, viId, vbHasDynamicChildren)
{
  if (!_bSkipCollapsed || _objActiveNode.open)
  {
    var oNode=FObjAddChildNode(_objActiveNode, vsHtmlText, vbOpen, false, viId, vbHasDynamicChildren);
    oNode.bFolder=true;
  }
}


function AddNode(vsHtmlText, vbOpen, viId, vbHasDynamicChildren)
{
  if (!_bSkipCollapsed || _objActiveNode.open)
    FObjAddChildNode(_objActiveNode, vsHtmlText, vbOpen, false, viId, vbHasDynamicChildren);
}

function AddNormalNode(vsId, vsLabel, vsIconURL, vsLinkURL, vsClass, vsName, vbOpen, vsImageTitle, vbHasDynamicChildren)
{
  AddNode('<a class="' + (vsClass ? vsClass : "HierarchyRow") + '" id="' + (vsId ? vsId : "") + '" ' + (vsName ? 'name="' + vsName + '" ' : '') +
          'title="' + vsLabel + '" ' + 
          (vsLinkURL ? 'onclick="javascript:SetHTMLObjectSelected(this);" href="' + vsLinkURL + '"' : '') + '>' + 
          (vsIconURL ? NewImage(vsIconURL, vsImageTitle) : '') + '&nbsp;' + vsLabel + '<\/a>', vbOpen, vsId, vbHasDynamicChildren);
}

function AddObjectlessLinkNode(vsId, vsLabel, vsIconURL, vsLinkURL, vsClass, vsName, vbOpen, vsImageTitle, vbHasDynamicChildren)
{
  AddNode('<a class="' + (vsClass ? vsClass : "HierarchyRow") + '" id="' + (vsId ? vsId : "") + '" ' + (vsName ? 'name="' + vsName + '" ' : '') +
          'title="' + vsLabel + '" ' + 
          (vsLinkURL ? 'href="' + vsLinkURL + '"' : '') + '>' + 
          (vsIconURL ? NewImage(vsIconURL, vsImageTitle) : '') + '&nbsp;' + vsLabel + '<\/a>', vbOpen, vsId, vbHasDynamicChildren);
}

function AddHeaderNode(vsHTML)
{
  FObjAddChildNode(_objActiveNode, vsHTML, true, false);
}


function AddSuperNode(vsName)
{
  var oNode = FObjAddChildNode(_objSuperNode, vsName, false, true);
  _objActiveNode = oNode;
  _iNodeCount = 0;
}

function PushNodeLevel()
{
  if (_objActiveNode.lastChild)
    _objActiveNode = _objActiveNode.lastChild;
}



function PopNodeLevel()
{
  if (_objActiveNode.parent)
    _objActiveNode = _objActiveNode.parent;
}

function SetDynamicTreeChildrenCallback(vCallback)
{
  _DynamicTreeChildrenCallback = vCallback;
}

function sGetExpandedNodes(vsTreeDivName)
{
  var sResult;
  if (!vsTreeDivName)
    sResult = FsGetExpandedNodesRec(_objSuperNode);
  else
    sResult = FsGetExpandedNodesRec(FHMTLTreeToHTML(FoGetSuperNode(vsTreeDivName)));
    
  if (!sResult)
    sResult = "0";
  return sResult;
}

function FsGetExpandedNodesRec(voNode)
{
  var sResult = "";
  if (voNode.open) {
    var sFullId = voNode.sFullId;
    if (sFullId)
      sResult += sFullId;
 
	var oCurrentNode = voNode.firstChild;
    while (oCurrentNode) {
      var sTmp = FsGetExpandedNodesRec(oCurrentNode);
      if (sTmp != "") {
        if (sResult != "")
          sResult += "," + sTmp;
        else
          sResult = sTmp;
      }
      oCurrentNode = oCurrentNode.next;
    }
  }
  return sResult;
}

var _bDisableAutomaticTreeNodeTitles;

function DisableAutomaticTreeNodeTitles()
{
  _bDisableAutomaticTreeNodeTitles = true;
}

// END PUBLIC FUNCTIONS
////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////
// CONSTANTS



var S_CLASS_WHITE      = 'WhiteRow';
var S_CLASS_GRAY       = 'GrayRow';
var S_SELECTED_CLASS   = 'SelectedHierarchyRow';
var S_NODE_ID_SUFFIX   = '_TN';

var ID_TREEDIV = 'divTree';

var B_NS4 = (document.layers)? true : false;

////////////////////////////////////////////////////////////////////////
// GLOBAL VARIABLES



var _objSuperNode      = new TreeNode(ID_TREEDIV, true, true); // A node never to be seen...
var _iNodeCount        = 0;

var _objActiveNode     = _objSuperNode;
var _urlTreeImagesPath = 'images/'; // Default path for images

var _sTreeWidth        = '100%';

var _htmlTreeimageEastClosed           = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed_e.gif');  //   - (+)
var _htmlTreeimageNorthEastClosed      = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed_ne.gif'); //  '- (+)
var _htmlTreeimageNorthEastSouthClosed = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed_nes.gif');//  |- (+)
var _htmlTreeimageEastOpen             = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open_e.gif');    //  '- (-)
var _htmlTreeimageNorthEastOpen        = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open_ne.gif');   //  '- (-)
var _htmlTreeimageNorthEastSouthOpen   = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open_nes.gif');  //  |- (-)
var _htmlTreeimageNorthEast            = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_ne.gif');        //  '-
var _htmlTreeimageNorthEastSouth       = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_nes.gif');       //  |-
var _htmlTreeimageNorthSouth           = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_ns.gif');        //  |
var _htmlTreeimageEmpty                = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_empty.gif');     //

var _DynamicTreeChildrenCallback;

// END GLOBAL VARIABLES
////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////
// IMAGE CREATION FUNCTIONS



function FBUpdateTreeImages(vbBookmark, vbHideLines, vsImageSuffix)
{
  if (vbHideLines) {
    _htmlTreeimageEastClosed           = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed' + vsImageSuffix + '.gif');
    _htmlTreeimageNorthEastClosed      = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed' + vsImageSuffix + '.gif');
    _htmlTreeimageNorthEastSouthClosed = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed' + vsImageSuffix + '.gif');
    _htmlTreeimageEastOpen             = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open' + vsImageSuffix + '.gif');
    _htmlTreeimageNorthEastOpen        = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open' + vsImageSuffix + '.gif');
    _htmlTreeimageNorthEastSouthOpen   = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open' + vsImageSuffix + '.gif');
    _htmlTreeimageNorthEast            = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_empty' + vsImageSuffix + '.gif');
    _htmlTreeimageNorthEastSouth       = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_empty' + vsImageSuffix + '.gif');
    _htmlTreeimageNorthSouth           = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_empty' + vsImageSuffix + '.gif');
    _htmlTreeimageEmpty                = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_empty' + vsImageSuffix + '.gif');
    return;
  }
  
  _htmlTreeimageEastClosed           = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed_e' + vsImageSuffix + '.gif');
  _htmlTreeimageNorthEastClosed      = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed_ne' + vsImageSuffix + '.gif');
  _htmlTreeimageNorthEastSouthClosed = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_closed_nes' + vsImageSuffix + '.gif');
  _htmlTreeimageEastOpen             = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open_e' + vsImageSuffix + '.gif');
  _htmlTreeimageNorthEastOpen        = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open_ne' + vsImageSuffix + '.gif');
  _htmlTreeimageNorthEastSouthOpen   = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_open_nes' + vsImageSuffix + '.gif');
  if (vbBookmark) {
    _htmlTreeimageNorthEast            = '';
  }
  else {
    _htmlTreeimageNorthEast            = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_ne' + vsImageSuffix + '.gif');
  }
  if (vbBookmark) {
    _htmlTreeimageNorthEastSouth       = '';
  }
  else {
    _htmlTreeimageNorthEastSouth       = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_nes' + vsImageSuffix + '.gif');
  }
  _htmlTreeimageNorthSouth           = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_ns' + vsImageSuffix + '.gif');
  _htmlTreeimageEmpty                = FHTMLCreateTreeImage(_urlTreeImagesPath + 'tree_empty.gif');
}



function FHTMLCreateTreeImage(vsImageFileName, vsTitle)
{
  if (vsImageFileName) {
    if (vsTitle)
      return '<img class="JSTreeImage" src="' + vsImageFileName + '" title="' + vsTitle + '" \/>';
    else
      return '<img class="JSTreeImage" src="' + vsImageFileName + '" \/>';

  }
  return '';
}



////////////////////////////////////////////////////////////////////////
// NODE CONSTRUCTOR FUNCTIONS

function TreeNode(vsHtmlText, vbOpen, vbSuperNode, vsId, voParentNode, vbHasDynamicChildren)
{
  this.open = vbOpen;
  this.bSuperNode = vbSuperNode;
  this.piNodeId = _iNodeCount++;

  if (vbSuperNode)
    this.arrNodeRefs = [];

  // foo<script>script to run</script>bar -> foo<,script to run</,bar
  var arParts = vsHtmlText.split("script>");
  for (var i = 0; i < arParts.length; ++i) {
    var sPart = arParts[i];
    if (sPart.charAt(sPart.length - 1) === '<')
      arParts[i] = sPart.slice(0, -1);
    else if (sPart.slice(sPart.length - 2) === "</")
      arParts[i] = eval("{" + sPart.slice(0, -2) + "}");
  }
  vsHtmlText = arParts.join(" ");

  if (vbSuperNode || _bDisableAutomaticTreeNodeTitles)
    this.title = vsHtmlText;
  else
    this.title = '<span id=\'_p' + this.piNodeId + '\'>' + vsHtmlText + '<\/span>';

  this.ToHTML = _FHMTLNodeToHTML;
  if (vsId && (vsId.indexOf("_") >= 0)) {
    var arIds = vsId.split("_");
    this.iProductId = parseInt(arIds[0]);
    this.iModelId = parseInt(arIds[2]);
    this.iObjectId = parseInt(arIds[3]);
    this.sFullId = vsId;
  }
  else {
    this.iObjectId = this.sFullId = vsId;
  }
  this.bSelected = false;
  this.pbHasDynamicChildren = vbHasDynamicChildren;
}

function FObjAddChildNode(voParentNode, vsHtmlText, vbOpen, vbSuperNode, viId, vbHasDynamicChildren) // Adds last child
{
  var oNode = new TreeNode(vsHtmlText, vbOpen, vbSuperNode, viId, voParentNode, vbHasDynamicChildren);

  if (voParentNode)
  {
    if (voParentNode.lastChild) // There already is a last child node, insert the new node last of the children
    {
      oNode.parent = voParentNode;
      oNode.previous = voParentNode.lastChild;
      voParentNode.lastChild.next = oNode;
      voParentNode.lastChild = oNode;
    }
    else // This is the only child node, therefore first and last
    {
      oNode.parent = voParentNode;
      voParentNode.firstChild = oNode;
      voParentNode.lastChild = oNode;
    }
  }

  return oNode;
}



////////////////////////////////////////////////////////////////////////
// PRIVATE HELPER FUNCTIONS

// Initializes a new instance of the StringBuilder class
// and appends the given value if supplied
function StringBuilder(value)
{
    this.strings = [""];
    this.append(value);
}

// Appends the given value to the end of this instance.
StringBuilder.prototype.append = function (value)
{
    if (value)
    {
        this.strings.push(value);
    }
}

// Clears the string buffer
StringBuilder.prototype.clear = function ()
{
    this.strings.length = 1;
}

// Converts this instance to a String.
StringBuilder.prototype.toString = function ()
{
    return this.strings.join("");
}

function FoGetNodeWithObjectIdRec(voNode, viObjectId)
{
  var oResult, oCurrentNode = voNode.firstChild;
  while (oCurrentNode) {
    if ((oCurrentNode.sFullId == viObjectId) || (oCurrentNode.iObjectid == viObjectId))
      return oCurrentNode;
    oResult = FoGetNodeWithObjectIdRec(oCurrentNode, viObjectId);
    if (oResult)
      return oResult;
    oCurrentNode = oCurrentNode.next;
  }
  return;
}

function FoGetNodeWithObjectId(viObjectId)
{
  var oResult, oCurrentNode = _objSuperNode.firstChild;
  while (oCurrentNode) {
    if ((oCurrentNode.sFullId == viObjectId) || (oCurrentNode.iObjectid == viObjectId))
      return oCurrentNode;
    oResult = FoGetNodeWithObjectIdRec(oCurrentNode, viObjectId);
    if (oResult)
      return oResult;
    oCurrentNode = oCurrentNode.next;
  }

  return;
}

function FoGetTreeNodeByTreeNodeIdRec(voNode, viNodeId)
{
  var oResult, oCurrentNode = voNode.firstChild;
  while (oCurrentNode) {
    if (oCurrentNode.piNodeId == viNodeId)
      return oCurrentNode;
    oResult = FoGetTreeNodeByTreeNodeIdRec(oCurrentNode, viNodeId);
    if (oResult)
      return oResult;
    oCurrentNode = oCurrentNode.next;
  }
  return;
}

function FoGetTreeNodeByTreeNodeId(viNodeId)
{
  viNodeId = viNodeId.substr(2);
  var oResult, oCurrentNode = _objSuperNode.firstChild;
  while (oCurrentNode) {
    if (oCurrentNode.piNodeId == viNodeId)
      return oCurrentNode;
    oResult = FoGetTreeNodeByTreeNodeIdRec(oCurrentNode, viNodeId);
    if (oResult)
      return oResult;
    oCurrentNode = oCurrentNode.next;
  }

  return;
}

function FoGetHTMLNodeByTreeNodeId(viNodeId)
{
  var oHTMLNode = document.getElementById("_p" + viNodeId);
  if (oHTMLNode) {
    oHTMLNode = oHTMLNode.childNodes[0];
    while (oHTMLNode && !oHTMLNode.id)
      oHTMLNode = oHTMLNode.nextSibling;     
  }
  return oHTMLNode;
}

function FoGetSuperNode(vsName)
{
  if (_objSuperNode.title == vsName)
    return _objSuperNode;

  var oCurrentNode = _objSuperNode.firstChild;
  while (oCurrentNode) {
    if (oCurrentNode.title == vsName)
      return oCurrentNode;
    oCurrentNode = oCurrentNode.next;
  }

  return;
}

function FsGetSuperNodeForNode(voNode)
{
  var oCurrentNode = voNode;
  while (oCurrentNode && !oCurrentNode.bSuperNode) {
    oCurrentNode = oCurrentNode.parent;
  }

  return oCurrentNode;
}

function FsGetTreeDivName(voNode)
{
  var oNode = FsGetSuperNodeForNode(voNode);
  if (oNode)
    return oNode.title;
  return;
}


////////////////////////////////////////////////////////////////////////
// HTML FUNCTIONS

function FsDrawTable(vsContent)
{
  return '<table border="0" cellspacing="0" cellpadding="0" width="' + _sTreeWidth + '">' + 
         vsContent +
         '</table>';
}

function FHMTLTreeToHTML(objStartingNode) // function to return the HTML code to view the tree and its status
{
  objStartingNode.arrNodeRefs.length = 0; // clear the node reference table every time the table is drawn
  return _DrawTableFunc(_DrawRowFunc(objStartingNode));
}

var FHMTLTreeToTable, FHMTLTreeToTableWithOwnerDrawRows;
if (navigator.userAgent.indexOf("MSIE") != -1) {
  // Initialize functions optimized for IE
  FHMTLTreeToTable = function (voStartingNode)

  {
    var objNode = voStartingNode.firstChild;
    var sb = new StringBuilder();
    
    while (objNode)
    {
      sb.append('<tr><td nowrap="nowrap">');
      sb.append(objNode.ToHTML(voStartingNode));
      sb.append('</td></tr>');
      objNode = FObjNextToDraw(objNode);
    }
  
    return sb.toString();
  }

  FHMTLTreeToTableWithOwnerDrawRows = function (voStartingNode)
  {
    var HTMLOutput = '';
    var objNode = voStartingNode.firstChild;
    var sb = new StringBuilder();
  
    while (objNode)
    {
      sb.append(objNode.ToHTML(voStartingNode, true));
      objNode = FObjNextToDraw(objNode);
    }
    
    return sb.toString();
  }
}
else {
  FHMTLTreeToTable = function (voStartingNode)
  {
    var HTMLOutput = '';
    var IntermediateHTMLOutput1 = '';
    var IntermediateHTMLOutput2 = '';
    var IntermediateHTMLOutput3 = '';
    var IntermediateHTMLOutput4 = '';
    var iCount1 = 0;
    var iCount2 = 0;
    var iCount3 = 0;
    var iCount4 = 0;
    var objNode = voStartingNode.firstChild;
    while (objNode)
    {
      if (iCount1 == 10) {
        IntermediateHTMLOutput2 += IntermediateHTMLOutput1;
        IntermediateHTMLOutput1 = '';
        iCount1 = 0;
        ++iCount2;
        if (iCount2 == 10) {
          IntermediateHTMLOutput3 += IntermediateHTMLOutput2;
          IntermediateHTMLOutput2 = '';
          iCount2 = 0;
          ++iCount3;
          if (iCount3 == 10) {
            IntermediateHTMLOutput4 += IntermediateHTMLOutput3;
            IntermediateHTMLOutput3 = '';
            iCount3 = 0;
            ++iCount4;
            if (iCount4 == 10) {
              HTMLOutput += IntermediateHTMLOutput4;
              IntermediateHTMLOutput4 = '';
              iCount4 = 0;
            }
          }
        }
      }
      IntermediateHTMLOutput1 += '<tr><td nowrap="nowrap">' + objNode.ToHTML(voStartingNode) + '</td></tr>';
      objNode = FObjNextToDraw(objNode);
      ++iCount1;
    }
    HTMLOutput += IntermediateHTMLOutput4 + IntermediateHTMLOutput3 + IntermediateHTMLOutput2 + IntermediateHTMLOutput1;
    return HTMLOutput;
  }

  FHMTLTreeToTableWithOwnerDrawRows = function (voStartingNode)
  {
    var HTMLOutput = '';
    var IntermediateHTMLOutput1 = '';
    var IntermediateHTMLOutput2 = '';
    var IntermediateHTMLOutput3 = '';
    var IntermediateHTMLOutput4 = '';
    var iCount1 = 0;
    var iCount2 = 0;
    var iCount3 = 0;
    var iCount4 = 0;
    var objNode = voStartingNode.firstChild;
  
    while (objNode)
    {
      if (iCount1 == 10) {
        IntermediateHTMLOutput2 += IntermediateHTMLOutput1;
        IntermediateHTMLOutput1 = '';
        iCount1 = 0;
        ++iCount2;
        if (iCount2 == 10) {
          IntermediateHTMLOutput3 += IntermediateHTMLOutput2;
          IntermediateHTMLOutput2 = '';
          iCount2 = 0;
          ++iCount3;
          if (iCount3 == 10) {
            IntermediateHTMLOutput4 += IntermediateHTMLOutput3;
            IntermediateHTMLOutput3 = '';
            iCount3 = 0;
            ++iCount4;
            if (iCount4 == 10) {
              HTMLOutput += IntermediateHTMLOutput4;
              IntermediateHTMLOutput4 = '';
              iCount4 = 0;
            }
          }
        }
      }
      IntermediateHTMLOutput1 += objNode.ToHTML(voStartingNode, true);
      objNode = FObjNextToDraw(objNode);
      ++iCount1;
    }
    HTMLOutput += IntermediateHTMLOutput4 + IntermediateHTMLOutput3 + IntermediateHTMLOutput2 + IntermediateHTMLOutput1;
    return HTMLOutput;
  }
}

function FObjNextToDraw(objNode)
{
  var currentNode = objNode;
  var nextNode = null;

  if (currentNode.open && currentNode.firstChild)
  {
    nextNode = currentNode.firstChild;
  }
  else
  {
    if (currentNode.next)
    {
      nextNode = currentNode.next;
    }
    else
    {
      while (currentNode.parent && !currentNode.parent.bSuperNode)
      {
        if (currentNode.parent.next)
        {
          nextNode = currentNode.parent.next;
          break;
        }
        else
        {
          currentNode = currentNode.parent;
        }
      }
    }
  }
//  if (nextNode) alert('NextNode for\n' + objNode.title + '\nis\n' + nextNode.title);
  return nextNode;
}

function _FHMTLNodeToHTML(voRootNode, vbOwnerDraw) // Private function for Node Objects, do not use as a normal function!
{
  var HTMLOutput = '';
  var objParentNode = (this.parent ? this.parent : null);
  // Create the node
  var sTitle='';
  if (this.bFolder)
    sTitle=this.title;  
  if (this.firstChild || this.pbHasDynamicChildren) // Check if the node has children
  { 
    if (this.open)
    {  // Portal 2.9
      HTMLOutput = '<a href="javascript: FBClickBranch(' + FSGetObjReference(this, voRootNode) + ')">';
      if (objParentNode && objParentNode.bSuperNode)
        HTMLOutput += _htmlTreeimageEastOpen + sTitle + '</a>';
      else
        HTMLOutput += (this.next ? _htmlTreeimageNorthEastSouthOpen : _htmlTreeimageNorthEastOpen) + sTitle + '</a>';
    }
    else
    {  // Portal 2.9
      HTMLOutput = '<a href="javascript: FBClickBranch(' + FSGetObjReference(this, voRootNode) + ')">';
      if (objParentNode && objParentNode.bSuperNode)
        HTMLOutput += _htmlTreeimageEastClosed + sTitle + '</a>';
      else
        HTMLOutput += (this.next ? _htmlTreeimageNorthEastSouthClosed : _htmlTreeimageNorthEastClosed)  + sTitle + '</a>';
    }
  }
  else
  {
    if (objParentNode && objParentNode.bSuperNode)
      HTMLOutput += _htmlTreeimageEmpty;
    else
      HTMLOutput = (this.next ? _htmlTreeimageNorthEastSouth : _htmlTreeimageNorthEast);
  }

  // Create the tree structure, left from the node
  while (objParentNode && !objParentNode.bSuperNode)
  {
    HTMLOutput = ((objParentNode.next && objParentNode.parent && !objParentNode.parent.bSuperNode) ?
                 _htmlTreeimageNorthSouth :
                 _htmlTreeimageEmpty) + HTMLOutput;
    objParentNode = objParentNode.parent; // Parent always exists while objParentNode cannot be _objSuperNode in this scope
  }
  if (vbOwnerDraw)
    HTMLOutput = this.title.replace(/<:hierarchy:>/gi, HTMLOutput);
  else if (!this.bFolder) 
    HTMLOutput += this.title;
  return HTMLOutput;
}

var _oExpandedNode;
var _bLocked = false;

function FBClickBranch(objNode,bFollowLink)
{
  if (!objNode) return;
  objNode.open = (objNode.open ? false : true);
  if (objNode.open && objNode.pbHasDynamicChildren) {
    if (_DynamicTreeChildrenCallback && !_bLocked) {
      _oExpandedNode = objNode;
      _bLocked = true;
      _DynamicTreeChildrenCallback(objNode, FDynamicNodesLoaded);
    }
  }
  else {
    UpdateTree(FsGetTreeDivName(objNode), true);
    return;
  }
}

function FDynamicNodesLoaded(vbSuccess, vsData)
{
  if (vbSuccess) {
    var oOrigActiveNode = _objActiveNode;
    _oExpandedNode.pbHasDynamicChildren = false;
    _objActiveNode = _oExpandedNode;
    eval(vsData);
    _objActiveNode = oOrigActiveNode;
    UpdateTree(FsGetTreeDivName(_oExpandedNode), true);
    _bLocked = false;
  }
}

function FSGetObjReference(objRef, voRootNode)
{
  var iIndex = voRootNode.arrNodeRefs.length;
  voRootNode.arrNodeRefs[iIndex] = objRef;
  return 'FoGetSuperNode(\'' + voRootNode.title + '\').arrNodeRefs[' + iIndex + ']';
}



////////////////////////////////////////////////////////////////////////
// HTML PAGE MANIPULATION FUNCTIONS



function FHTMLCreateDiv(sDivID)
{
  return '<div id="' + sDivID + '"></div>';
}

function FBWriteToDiv(sDivID,htmlText)
{
  if (document.getElementById)
  {
    if (!document.getElementById(sDivID))
      return false;
    document.getElementById(sDivID).innerHTML = htmlText;
  }
  else
  {
    if (document.all)
    {
      if (!document.all(sDivID))
        return false;
      document.all(sDivID).innerHTML = htmlText;
    }
    else
    {
      if (B_NS4)
      {
        var div = eval('document.' + sDivID);
        if (!div)
          return false;
        div.document.open();
        div.document.write(htmlText);
        div.document.close();
      }
    }
  }
  return true;
}

var _DrawRowFunc = FHMTLTreeToTable;
var _DrawTableFunc = FsDrawTable;
